chiark / gitweb /
test suite: t-tagupl-run-drs: New source parameter
[dgit.git] / tests / lib
index bd06d20d21cc7364ce1e056777e5fd03e35b4b29..c37c512d74eaedb591bcecba6a7990b85cac3a2f 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -17,6 +17,8 @@ funcs: ${FUNCNAME[*]}
 lines: ${BASH_LINENO[*]}
 files: ${BASH_SOURCE[*]}
 END
+       t-save-artifacts
+
        exit 16
 }
 
@@ -29,18 +31,25 @@ t-set-intree
 : ${DGIT_TEST_DEBUG=-D}
 export DGIT_TEST_DEBUG
 
+: ${DGIT_TEST_DEBPUSH_DEBUG=x}
+export DGIT_TEST_DEBPUSH_DEBUG
+
 : ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
 
-export GIT_COMMITTER_DATE='1515000000 +0100'
-export GIT_AUTHOR_DATE='1515000000 +0100'
+export GIT_COMMITTER_DATE='1530000000 +0100'
+export GIT_AUTHOR_DATE='1530000000 +0100'
+
+export LC_CTYPE=C.UTF-8
 
 root=`pwd`
 troot=$root/tests
 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
 export DGIT_TEST_TROOT=$troot
+bpd=..
 
 tmp=$ADTTMP
 if [ x"$tmp" = x ]; then
+       export DGIT_TEST_BYHAND=1
        mkdir -p tests/tmp
        tmpbase=$troot/tmp
        tmp=tests/tmp/$testname
@@ -58,9 +67,11 @@ t-set-using-tmp
 test -f $tmp/.save-env || \
 env -0 >$tmp/.save-env
 
-ln -f $troot/ssh ssh
+ln -sf $troot/ssh ssh
 
 export DEBCHANGE_VENDOR=dpkg
+unset VISUAL
+unset GIT_EDITOR
 
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
@@ -70,6 +81,9 @@ incoming              = $tmp/incoming
 run_dinstall           = 0
 END
 
+schroot=${DGIT_SCHROOT_CHROOT:-build}
+# Pretty much any Debian sid snapshot schroot will do.
+
 : ${t_archive_method:=aq}
 : ${tagpfx:=archive/test-dummy}
 : ${suitespecs:=sid:unstable}
@@ -83,7 +97,9 @@ t-expect-fail () {
        local mpat="$1"; shift
 
        set +o pipefail
-       LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
+       LC_MESSAGES=${expect_fail_lcmessages-C} \
+       LANGUAGE=${expect_fail_lcmessages-C} \
+       "$@" 2>&1 | tee $tmp/t.output
        local ps="${PIPESTATUS[*]}"
        set -o pipefail
 
@@ -152,7 +168,7 @@ t-reporefs () {
         exec >"$outputfile"
         if test -d $whichrepo; then
                cd $whichrepo
-               git show-ref |sort
+               git show-ref |t-sort
        fi)
 }
 
@@ -333,7 +349,7 @@ t-archive () {
        v=$2
        local dscf=${p}_$2.dsc
        rm -f $tmp/mirror/pool/main/${p}_*
-       ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
+       ln -s $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
        t-archive-query $suite
        rm -rf $tmp/extract
        mkdir $tmp/extract
@@ -395,6 +411,13 @@ t-git-fsck () {
        esac
 }
 
+t-check-only-bpd () {
+       if [ "$bpd" = .. ]; then return; fi
+       t-files-notexist \
+               $tmp/*.{deb,changes,dsc,buildinfo} \
+               $tmp/*.{tar,diff}.*
+}
+
 t-fscks () {
        (
        shopt -s nullglob
@@ -407,10 +430,20 @@ t-fscks () {
 
 t-ok () {
        : '========================================'
+       t-check-only-bpd
        t-fscks
+       t-save-artifacts
        echo ok.
 }
 
+t-save-artifacts () {
+       artifacts="$AUTOPKGTEST_ARTIFACTS"
+       if [ x"$artifacts" = x ]; then return; fi
+       if [ x"tmp" = x ]; then return; fi
+       GZIP=-1v tar -C "$tmp" -zc -f "$artifacts/${0##*/}.tar.gz" \
+               --exclude=\*.tar .
+}
+
 t-rm-dput-dropping () {
        rm -f $tmp/${p}_${v}_*.upload
 }
@@ -490,6 +523,14 @@ t-setup-done () {
                ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
        done
 
+       perl >&4 -"I$root" -MDebian::Dgit -we '
+               foreach my $vn (grep m/^DGIT_TEST_REAL_/, keys %ENV) {
+                       print STDERR "saving-exporting $vn\n";
+                       printf "export %s=%s\n", $vn, shellquote $ENV{$vn}
+                               or die $!;
+               }
+       '
+
        (set -e; cd $tmp; tar cf $import.tar $savedirs)
 
        printf >&4 "\n%s\n" "$importeval"
@@ -658,6 +699,12 @@ t-push-was-source-only () {
         done
 }
 
+t-push-included () {
+    for f in $@; do
+        stat $tmp/incoming/$f
+    done
+}
+
 t-pushed-good () {
        local branch=$1
        local suite=${2:-sid}
@@ -685,6 +732,12 @@ t-pushed-good-core () {
        git verify-tag `t-v-tag`
 }
 
+t-pushed-good-check-changes () {
+       changes_filename="$tmp/incoming/${p}_${v}_*.changes"
+        grep -E "^Distribution: $suite" $changes_filename
+        grep -E "^Version: $v" $changes_filename
+}
+
 t-splitbrain-pushed-good--unpack () {
        cd $tmp
        rm -rf t-unpack
@@ -694,6 +747,7 @@ t-splitbrain-pushed-good--unpack () {
        ln -s $tmp/incoming/*.orig*.tar* . ||:
        ln -s $incoming_dsc .
        ln -s ${incoming_dsc/.dsc/.debian.tar}* .
+       ln -s ${incoming_dsc/.dsc/.tar}* . ||:
        dpkg-source "$@" -x *.dsc
        cd */.
        git init
@@ -740,16 +794,21 @@ t-splitbrain-pushed-good-end-made-dep14 () {
        cd $tmp/$p
 }
 
-t-splitbrain-rm-gitignore-patch () {
+t-splitbrain-rm-1-patch () {
+       local patchname=$1
        perl -i -pe '
-               next unless $_ eq "auto-gitignore\n";
+               next unless $_ eq "'"$patchname"'\n";
                die if $counter++;
                chomp;
-               rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
+               rename "debian/patches/$_", "../t-'"$patchname"'" or die $!;
                $_ = "";
        ' debian/patches/series
 }
 
+t-splitbrain-rm-gitignore-patch () {
+       t-splitbrain-rm-1-patch auto-gitignore
+}
+
 t-gbp-pushed-good () {
        local suite=${1:-sid}
        t-splitbrain-pushed-good-start
@@ -784,18 +843,27 @@ t-gbp-pushed-good () {
 }
 
 t-unapplied-pushed-good () {
+       local suite=${1:-sid}
        t-splitbrain-pushed-good-start
        t-splitbrain-pushed-good--unpack --skip-patches
        t-splitbrain-pushed-good-end-made-dep14
 }
 
 t-dpm-pushed-good () {
+       local suite=${1:-sid}
        t-splitbrain-pushed-good-start
        t-splitbrain-pushed-good--unpack
        t-splitbrain-rm-gitignore-patch
        t-splitbrain-pushed-good-end-made-dep14
 }
 
+t-split-unchanged-pushed-good () {
+       local suite=${1:-sid}
+       t-splitbrain-pushed-good-start
+       t-splitbrain-pushed-good--unpack
+       t-splitbrain-pushed-good-end-made-dep14
+}
+
 t-commit-build-push-expect-log () {
        local msg=$1
        local mpat=$2
@@ -996,17 +1064,49 @@ t-make-badcommit () {
        t-expect-fsck-fail $badcommit
 }
 
+t-make-orig () {
+       # leaves ust set to filename of orig tarball
+       local p=$1
+       local v=$2
+       local tag=${3-v$2}
+       ust=${p}_${v}.orig.tar.gz
+       GZIP=-1 git archive -o $bpd/$ust --prefix=${p}-${v}/ $tag
+}
+
+t-merge-conflicted-stripping-conflict-markers () {
+       local otherbranch=$1
+       local file=$2
+
+       t-expect-fail F:"Merge conflict in $file" \
+       git merge $otherbranch
+
+       perl -i~ -ne 'print unless m{^(?:\<\<\<|\>\>\>|===)}' "$file"
+       git add "$file"
+       git commit --no-edit
+}
+
 t-commit () {
        local msg=$1
        v=${2:-${majorv:-1}.$revision}
-       dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
+       $troot/tstunt/debchange \
+               --force-distribution -v$v --distribution ${3:-unstable} "$1"
        git add debian/changelog
        debcommit
        revision=$(( ${revision-0} + 1 ))
 }
 
+t-dch-r-rune () {
+       local cmd="$1"; shift
+       local suite=${1-unstable}
+       $cmd -r -D "$suite" ''
+}
+
+t-dch-commit-r () {
+       t-dch-r-rune t-dch-commit "$@"
+}
+
 t-dch-commit () {
-       faketime @"${GIT_AUTHOR_DATE% *}" dch "$@"
+       $troot/tstunt/debchange "$@"
        git commit -m "dch $*" debian/changelog
 }
 
@@ -1018,7 +1118,6 @@ t-drs () {
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
- t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
        cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
        cp $troot/suites $tmp/.
        cp $troot/suites $tmp/suites-master
@@ -1040,15 +1139,6 @@ t-drs () {
        ln -sf /bin/true $drs_dispatch/policy-hook
 }
 
-t-newtag () {
- export tagpfx=archive/test-dummy
- t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
-}
-t-oldtag () {
- export tagpfx=test-dummy
- t-git-config dgit-distro.test-dummy.dgit-tag-format old
-}
-
 t-dsd () {
        t-drs
  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
@@ -1107,6 +1197,53 @@ t-policy-periodic () {
        : '))))))))))))))))))))))))))))))))))))))))'
 }
 
+t-tagupl-settings () {
+       export DGIT_DRS_EMAIL_NOREPLY=noreply@example.org
+       export DGIT_DRS_SENDMAIL=$troot/tstunt/sendmail
+       export DGIT_DRS_DGIT=$troot/tstunt/dgit
+       t-chain-test-somehow
+
+       mkdir ../pretend-salsa
+       (set -e; cd ../pretend-salsa; git init --bare)
+       git remote add salsa $tmp/pretend-salsa
+       # git branch --set-upstream-to complains, so
+       git config branch.master.remote salsa
+       git config branch.master.merge refs/heads/master
+}
+
+t-tagupl-run-drs () {
+       local source=$1
+       cd ..
+       cd tagupl
+
+       DGIT_DRS_ANY_URL=1 \
+       DGIT_DRS_MODE="tag2upload $source $tagname" \
+        $troot/drs-git-ext 
+
+       cd $tmp/$p
+}
+
+t-tagupl-test () {
+       ${DGIT_DEBPUSH_TEST-git debpush} \
+               --distro=test-dummy -u Senatus "$@"
+
+       mkdir ../tagupl
+       t-tagupl-run-drs $tmp/$p
+
+       t-dgit fetch
+       t-pushed-good master
+}
+
+t-buildproductsdir-config () {
+       bpd=$tmp/bpd
+       t-git-config dgit.default.build-products-dir $bpd
+       mkdir -p $bpd
+       cat <<END >>$tmp/.gbp.conf
+[buildpackage]
+export-dir = $bpd
+END
+}
+
 t-restrict () {
        local restriction=$1
        (cd $root; t-restriction-$restriction >&2)
@@ -1116,13 +1253,17 @@ t-dependencies () {
        : "Hopefully installed: $*"
 }
 
+t-chain-test-somehow () {
+       export DGIT_TEST_TESTNAME="$testname"
+       export DGIT_TEST_TMPBASE="$tmpbase"
+       export ADTTMP=$tmp
+}
+
 t-chain-test () {
+       t-chain-test-somehow
        local ct=$1
        local d=${0%/*}
        cd $root
-       export DGIT_TEST_TESTNAME="$testname"
-       export DGIT_TEST_TMPBASE="$tmpbase"
-       export ADTTMP=$tmp
        exec "$d/$ct"
 }      
 
@@ -1134,7 +1275,11 @@ t-alt-test () {
 
 t-git-config dgit.default.old-dsc-distro test-dummy
 
-case "$0" in
-*/gnupg) ;;
-*)     t-setup-import gnupg    ;;
-esac
+for import in ${autoimport-gnupg}; do
+       case "$0" in
+       */$import) ;;
+       *)
+               t-setup-import $import
+               ;;
+       esac
+done